using System.Text.Json.Serialization;

namespace Luski.Clesses;

public class ServerInfo
{
    [JsonInclude]
    [JsonPropertyName("domain")]
    public string Domain { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("version")]
    public string Version { get; set; } = "v1";
    [JsonInclude]
    [JsonPropertyName("is_main")]
    public bool Main { get; set; } = false;
    [JsonInclude]
    [JsonPropertyName("is_secure")]
    public bool Secure { get; set; } = true;
}