using System.Security.Cryptography;
using System.Text;
using System.Text.Json;

namespace Luski;

public class Temp
{
    internal static string pw = "bobbob";

        public static class File
        {
            internal static void SetOfflineKey(string key)
            {
                MakeFile("Server.GetKeyFilePath", pw);
                LuskiDataFile? fileLayout = JsonSerializer.Deserialize<LuskiDataFile>(FileString("Server.GetKeyFilePath", pw));
                fileLayout.OfflineKey = key;
                fileLayout.Save("Server.GetKeyFilePath", pw);
            }

           

            internal static string? GetOfflineKey()
            {
                MakeFile("/home/jacob/.config/JacobTech/Luski/Dev/win-x64/Data/1/keys.lsk", pw);
                LuskiDataFile? fileLayout = JsonSerializer.Deserialize<LuskiDataFile>(FileString("Server.GetKeyFilePath", pw));
                return fileLayout?.OfflineKey;
            }
            
            public static LuskiDataFile GetFile()
            {
                MakeFile("/home/jacob/.config/JacobTech/Luski/Dev/win-x64/Data/2/keys.lsk", pw);
                return JsonSerializer.Deserialize<LuskiDataFile>(FileString("/home/jacob/.config/JacobTech/Luski/Dev/win-x64/Data/2/keys.lsk", pw))!;
            }

            private static string FileString(string path, string password)
            {
                byte[] passwordBytes = Encoding.UTF8.GetBytes(password);
                byte[] salt = new byte[100];
                FileStream fsCrypt = new(path, FileMode.Open);
                fsCrypt.Read(salt, 0, salt.Length);
                RijndaelManaged AES = new()
                {
                    KeySize = 256,
                    BlockSize = 128
                };
                Rfc2898DeriveBytes key = new(passwordBytes, salt, 50000);
                AES.Key = key.GetBytes(AES.KeySize / 8);
                AES.IV = key.GetBytes(AES.BlockSize / 8);
                AES.Padding = PaddingMode.PKCS7;
                AES.Mode = CipherMode.CFB;
                CryptoStream cs = new(fsCrypt, AES.CreateDecryptor(), CryptoStreamMode.Read);
                MemoryStream fsOut = new();
                int read;
                byte[] buffer = new byte[1048576];
                try
                {
                    while ((read = cs.Read(buffer, 0, buffer.Length)) > 0)
                    {
                        fsOut.Write(buffer, 0, read);
                    }
                }
                catch (CryptographicException ex_CryptographicException)
                {
                    Console.WriteLine("CryptographicException error: " + ex_CryptographicException.Message);
                }
                catch (Exception ex)
                {
                    Console.WriteLine("Error: " + ex.Message);
                }
                fsOut.Seek(0, SeekOrigin.Begin);
                using BinaryReader reader = new(fsOut);
                byte[] by = reader.ReadBytes((int)fsOut.Length);
                fsOut.Close();
                fsCrypt.Close();
                return Encoding.UTF8.GetString(by);
            }

            public static class Channels
            {
                private static string GetKey(long channel)
                {
                    LuskiDataFile? fileLayout;
                    IEnumerable<ChannelLayout>? lis;
                    try
                    {
#pragma warning disable CS8603 // Possible null reference return.
                       // if (channel == 0) return myPrivateKey;
#pragma warning restore CS8603 // Possible null reference return.
                        MakeFile("Server.GetKeyFilePath", pw);
                        fileLayout = JsonSerializer.Deserialize<LuskiDataFile>(FileString("Server.GetKeyFilePath", pw));
                        lis = fileLayout?.channels?.Where(s => s.id == channel);
                        if (lis?.Count() > 0)
                        {
                            return lis.First().key;
                        }
                        throw new Exception("You dont have a key for that channel");
                    }
                    finally
                    {
                        fileLayout = null;
                        lis = null;
                    }
                }

                internal static string GetKeyBranch(long channel)
                {
                    LuskiDataFile? fileLayout;
                    IEnumerable<ChannelLayout>? lis;
                    try
                    {
#pragma warning disable CS8603 // Possible null reference return.
                       // if (channel == 0) return myPrivateKey;
#pragma warning restore CS8603 // Possible null reference return.
                        MakeFile("Server.GetKeyFilePathBr(branch.ToString())", pw);
                        fileLayout = JsonSerializer.Deserialize<LuskiDataFile>(FileString("", pw));
                        lis = fileLayout?.channels?.Where(s => s.id == channel);
                        if (lis?.Count() > 0)
                        {
                            return lis.First().key;
                        }
                        throw new Exception("You dont have a key for that channel");
                    }
                    finally
                    {
                        fileLayout = null;
                        lis = null;
                    }
                }

                public static void AddKey(long channel, string key)
                {
                    MakeFile("Server.GetKeyFilePath", pw);
                    LuskiDataFile? fileLayout = JsonSerializer.Deserialize<LuskiDataFile>(FileString("Server.GetKeyFilePath", pw));
                    fileLayout?.Addchannelkey(channel, key);
                    fileLayout?.Save("Server.GetKeyFilePath", pw);
                }
            }

            private static void MakeFile(string dir, string password)
            {
                if (!System.IO.File.Exists(dir))
                {
                    LuskiDataFile? l = JsonSerializer.Deserialize<LuskiDataFile>("{\"channels\":[]}");
                    l?.Save(dir, password);
                }
            }

            public class LuskiDataFile
            {
                public static LuskiDataFile GetDataFile(string path, string password)
                {
                    MakeFile(path, password);
                    return JsonSerializer.Deserialize<LuskiDataFile>(FileString(path, password));
                }

                internal static LuskiDataFile GetDefualtDataFile()
                {
                    return GetDataFile("Server.GetKeyFilePath", pw);
                }
                
                public ChannelLayout[]? channels { get; set; } = default!;

                public string? OfflineKey { get; set; } = default!;

                public void Save(string file, string password)
                {
                    byte[] salt = new byte[100];
                    RandomNumberGenerator? provider = RandomNumberGenerator.Create();
                    provider.GetBytes(salt);
                    FileStream fsCrypt = new(file, FileMode.Create);
                    byte[] passwordBytes = Encoding.UTF8.GetBytes(password);
                    RijndaelManaged AES = new()
                    {
                        KeySize = 256,
                        BlockSize = 128,
                        Padding = PaddingMode.PKCS7
                    };
                    Rfc2898DeriveBytes key = new(passwordBytes, salt, 50000);
                    AES.Key = key.GetBytes(AES.KeySize / 8);
                    AES.IV = key.GetBytes(AES.BlockSize / 8);
                    AES.Mode = CipherMode.CFB;
                    fsCrypt.Write(salt, 0, salt.Length);
                    CryptoStream cs = new(fsCrypt, AES.CreateEncryptor(), CryptoStreamMode.Write);
                    string tempp = JsonSerializer.Serialize(this);
                    MemoryStream fsIn = new(Encoding.UTF8.GetBytes(tempp));
                    byte[] buffer = new byte[1048576];
                    int read;
                    try
                    {
                        while ((read = fsIn.Read(buffer, 0, buffer.Length)) > 0)
                        {
                            cs.Write(buffer, 0, read);
                        }
                        fsIn.Close();
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Error: " + ex.Message);
                    }
                    finally
                    {
                        cs.Close();
                        fsCrypt.Close();
                    }
                }

                public void Addchannelkey(long chan, string Key)
                {
                    List<ChannelLayout>? chans = channels?.ToList();
                    if (chans is null) chans = new();
                    if (!(chans?.Where(s => s.id == chan).Count() > 0))
                    {
                        ChannelLayout l = new()
                        {
                            id = chan,
                            key = Key
                        };
                        chans?.Add(l);
                        channels = chans?.ToArray();
                    }
                    else
                    {
                        chans.Remove(chans.Where(s => s.id == chan).First());
                        ChannelLayout l = new()
                        {
                            id = chan,
                            key = Key
                        };
                        chans?.Add(l);
                        channels = chans?.ToArray();
                    }
                }
            }

            public class ChannelLayout
            {
                public long id { get; set; } = default!;
                public string key { get; set; } = default!;
            }
        }
}